
//////////////////////////////////////////////////////////////////////////////
// CProxy_oVFWEvents
template <class T>
class CProxy_oVFWEvents : public IConnectionPointImpl<T, &DIID__oVFWEvents, CComDynamicUnkArray>
{
public:
//methods:
//_oVFWEvents : IDispatch
public:
	void Fire_DriversEnum(
		long Index,
		IoVFWDriverInfo * * driver)
	{
		VARIANTARG* pvars = new VARIANTARG[2];
		for (int i = 0; i < 2; i++)
			VariantInit(&pvars[i]);
		T* pT = (T*)this;
		pT->Lock();
		IUnknown** pp = m_vec.begin();
		while (pp < m_vec.end())
		{
			if (*pp != NULL)
			{
				pvars[1].vt = VT_I4;
				pvars[1].lVal= Index;
				pvars[0].vt = VT_EMPTY | VT_BYREF | VT_BYREF;
				pvars[0].byref= driver;
				DISPPARAMS disp = { pvars, NULL, 2, 0 };
				IDispatch* pDispatch = reinterpret_cast<IDispatch*>(*pp);
				pDispatch->Invoke(0x1, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &disp, NULL, NULL, NULL);
			}
			pp++;
		}
		pT->Unlock();
		delete[] pvars;
	}

};

