VERSION 5.00
Object = "{5A5FFDA1-F0A7-11D1-969F-002018631632}#1.0#0"; "oVFW.ocx"
Begin VB.Form frmOVFWTest 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Video For Windows control test - by Ofer LaOr"
   ClientHeight    =   3855
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7170
   Icon            =   "frmOVFWTest.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   257
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   478
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdSaveTo 
      Caption         =   "Save to c:\test.bmp"
      Height          =   495
      Left            =   5640
      TabIndex        =   11
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Height          =   495
      Left            =   5640
      TabIndex        =   10
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton cmdStopStart 
      Caption         =   "Start/Stop video"
      Height          =   375
      Left            =   5520
      TabIndex        =   8
      Top             =   240
      Width           =   1455
   End
   Begin VB.CommandButton cmdEnumDrivers 
      Caption         =   "Enum Drivers"
      Height          =   375
      Left            =   5520
      TabIndex        =   7
      Top             =   720
      Width           =   1455
   End
   Begin VB.CheckBox chkOverlay 
      Caption         =   "Overlay"
      Height          =   255
      Left            =   5640
      TabIndex        =   6
      Top             =   1200
      Width           =   1335
   End
   Begin VB.CommandButton cmdSource 
      Caption         =   "src"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5520
      TabIndex        =   5
      Top             =   1560
      Width           =   375
   End
   Begin VB.CommandButton cmdFormat 
      Caption         =   "frm"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5880
      TabIndex        =   4
      Top             =   1560
      Width           =   375
   End
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "dsp"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6240
      TabIndex        =   3
      Top             =   1560
      Width           =   375
   End
   Begin VB.CommandButton cmdCompression 
      Caption         =   "cmp"
      Height          =   375
      Left            =   6600
      TabIndex        =   2
      Top             =   1560
      Width           =   495
   End
   Begin VB.TextBox txtVidSource 
      Height          =   285
      Left            =   6360
      MaxLength       =   1
      TabIndex        =   1
      Text            =   "0"
      Top             =   2040
      Width           =   615
   End
   Begin oVFWCtl.oVFW oVFW1 
      Height          =   3600
      Left            =   240
      OleObjectBlob   =   "frmOVFWTest.frx":030A
      TabIndex        =   0
      Top             =   120
      Width           =   4800
   End
   Begin VB.Label Label1 
      Caption         =   "Vid source:"
      Height          =   255
      Left            =   5400
      TabIndex        =   9
      Top             =   2040
      Width           =   975
   End
End
Attribute VB_Name = "frmOVFWTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim fShowVideo As Boolean

Private Sub chkOverlay_Click()
    oVFW1.fOverlay = IIf(chkOverlay.Value = 1, True, False)
End Sub

Private Sub cmdCompression_Click()
On Error Resume Next
    oVFW1.CurDriver.DlgVideoCompression
End Sub

Private Sub cmdCopy_Click()
    oVFW1.CaptureEditCopy
End Sub

Private Sub cmdDisplay_Click()
On Error Resume Next
    oVFW1.CurDriver.DlgVideoDisplay
End Sub

Private Sub cmdEnumDrivers_Click()
    oVFW1.EnumDrivers
End Sub

Private Sub cmdFormat_Click()
On Error Resume Next
    oVFW1.CurDriver.DlgVideoFormat
End Sub

Private Sub cmdSaveTo_Click()
    oVFW1.CaptureToBitmapFile "c:\test.bmp"
End Sub

Private Sub cmdSource_Click()
On Error Resume Next
    oVFW1.CurDriver.DlgVideoSource
End Sub
Sub CheckEnabled()
    chkOverlay.Visible = oVFW1.CurDriver.SupportsOverlay
    cmdSource.Enabled = oVFW1.CurDriver.SupportsDlgVideoSource
    cmdFormat.Enabled = oVFW1.CurDriver.SupportsDlgVideoFormat
    cmdDisplay.Enabled = oVFW1.CurDriver.SupportsDlgVideoDisplay
End Sub

Private Sub cmdStopStart_Click()
    fShowVideo = Not fShowVideo
    Dim success As Boolean
On Error Resume Next
    oVFW1.PreviewRate = 15
    oVFW1.iVideo = CInt(txtVidSource)
On Error GoTo 0
    If Not fShowVideo Then
        CheckEnabled
    End If
    success = oVFW1.ShowLiveVideo(fShowVideo)
    If fShowVideo Then
        CheckEnabled
    End If
End Sub

Private Sub Form_Load()
    chkOverlay.Value = IIf(oVFW1.fOverlay, 1, 0)
End Sub


Private Sub oVFW1_DriversEnum(ByVal Index As Long, driver As oVFWCtl.IoVFWDriverInfo)
    Dim sDriverInfo As String
    sDriverInfo = driver.Name + vbCrLf
    sDriverInfo = sDriverInfo + driver.Version + vbCrLf
    sDriverInfo = sDriverInfo + "Index: " + CStr(Index) + vbCrLf
    sDriverInfo = sDriverInfo + "Overlay: " + CStr(driver.SupportsOverlay) + vbCrLf
    sDriverInfo = sDriverInfo + "Video display:" + CStr(driver.SupportsDlgVideoDisplay) + vbCrLf
    sDriverInfo = sDriverInfo + "Video source:" + CStr(driver.SupportsDlgVideoSource) + vbCrLf
    sDriverInfo = sDriverInfo + "Video format:" + CStr(driver.SupportsDlgVideoFormat) + vbCrLf
    MsgBox sDriverInfo
End Sub

Private Sub txtVidSource_KeyPress(KeyAscii As Integer)
    ' numeric edit box (crude but it works)...
    If Not (IsNumeric(Chr$(KeyAscii))) Then
        KeyAscii = 0
    End If
End Sub

